﻿var tsmu = app.activeDocument.viewPreferences.textSizeMeasurementUnits;
var lmu = app.activeDocument.viewPreferences.strokeMeasurementUnits;
app.activeDocument.viewPreferences.textSizeMeasurementUnits = 2054188905;
app.activeDocument.viewPreferences.strokeMeasurementUnits = 2054188905;

var sel = app.activeDocument.selection[0];
var chpt = sel.paragraphs[0].characters[0].pointSize;
var chbl = sel.paragraphs[0].characters[0].baselineShift;

var clist = "";
for(i=0; i<app.activeDocument.swatches.length; i++) {
	clist = clist + app.activeDocument.swatches[i].name + ",";
	}
clist = clist.replace ("Registration,", "");
clist = clist.replace ("None,Paper,", "");
clist = clist.substring (0, clist.length-1);
clist = clist.split (",");

var dlg = app.dialogs.add({name:"囲みタイトル作成支援"});
var dlc = dlg.dialogColumns.add();
with(dlc.dialogRows.add()){
	staticTexts.add({staticLabel:"色指定"});
	var selcolor = dropdowns.add({stringList: clist, selectedIndex:0, minWidth:100});
	}
with(dlc.dialogRows.add()){
	staticTexts.add({staticLabel:"太さ指定（pt）"});
	var mae = realEditboxes.add({minimumValue:0, maximumValue:100, editValue:Math.round(chpt*1.3)});
	}
with(dlc.dialogRows.add()){
	staticTexts.add({staticLabel:"外罫太さ（pt）"});
	var usiro = realEditboxes.add({minimumValue:0, maximumValue:1000, editValue:0});
	}
with(dlc.dialogRows.add()){
	staticTexts.add({staticLabel:""});
		}
with(dlc.radiobuttonGroups.add()){ 
	var chk1 = radiobuttonControls.add({staticLabel: "直線", minWidth:120, checkedState:true});
	var chk2 = radiobuttonControls.add({staticLabel: "角丸", minWidth:120});
	}
with(dlc.dialogRows.add()){
	staticTexts.add({staticLabel:""});
		}
with(dlc.dialogRows.add()){
	staticTexts.add({staticLabel:"左右アキ（0で列、0以上で文字）"});
	}
with(dlc.dialogRows.add()){
	var yoko = realEditboxes.add({minimumValue:0, maximumValue:100, editValue:0});
	}
var flag = dlg.show();
	
if (flag == true) {
	var cstyle = selcolor.stringList[selcolor.selectedIndex];
	var maekei = mae.editValue;
	var tmpusiro = usiro.editValue;
	var yokoaki = yoko.editValue;
	sel.paragraphs[0].ruleAbove = true;
	sel.paragraphs[0].ruleAboveLineWeight = maekei;
	if (yokoaki == 0) {
		sel.paragraphs[0].ruleAboveWidth = 1265399652;
		sel.paragraphs[0].ruleAboveLeftIndent = 0;
		sel.paragraphs[0].ruleAboveRightIndent = 0;
		} else {
			sel.paragraphs[0].ruleAboveWidth = 1886681207;
			sel.paragraphs[0].ruleAboveLeftIndent = - yokoaki + "mm";
			sel.paragraphs[0].ruleAboveRightIndent = - yokoaki + "mm";
			}
	if (chk1.checkedState == true) {
		sel.paragraphs[0].ruleAboveType = app.activeDocument.stripedStrokeStyles.item("ベタ");
		} else {sel.paragraphs[0].ruleAboveType = app.activeDocument.stripedStrokeStyles.item("句点");
			}
	sel.paragraphs[0].ruleAboveOffset = (- (maekei - chpt) / 2) + chbl + "pt";
	sel.paragraphs[0].ruleAboveColor = app.activeDocument.swatches.item(cstyle);
	sel.paragraphs[0].ruleAboveGapColor = app.activeDocument.swatches.item(cstyle);
	
	if (tmpusiro > 0) {
		usirokei = maekei - (tmpusiro * 2);
		sel.paragraphs[0].ruleBelow = true;
		sel.paragraphs[0].ruleBelowLineWeight = usirokei;
		if (chk1.checkedState == true) {
			sel.paragraphs[0].ruleBelowType = app.activeDocument.stripedStrokeStyles.item("ベタ");
			} else {sel.paragraphs[0].ruleBelowType = app.activeDocument.stripedStrokeStyles.item("句点");
				}
		sel.paragraphs[0].ruleBelowOffset = ((usirokei - chpt) / 2 - usirokei) - chbl + "pt";
		sel.paragraphs[0].ruleBelowColor = app.activeDocument.swatches.item("Paper");
		sel.paragraphs[0].ruleBelowGapColor = app.activeDocument.swatches.item("Paper");
		if (yokoaki == 0) {
			sel.paragraphs[0].ruleBelowWidth = 1265399652;
			sel.paragraphs[0].ruleBelowLeftIndent = tmpusiro + "pt";
			sel.paragraphs[0].ruleBelowRightIndent = tmpusiro + "pt";
			} else {
				sel.paragraphs[0].ruleBelowWidth = 1886681207;
				sel.paragraphs[0].ruleBelowLeftIndent = - yokoaki *2.835 + tmpusiro + "pt";
				sel.paragraphs[0].ruleBelowRightIndent = - yokoaki * 2.835 + tmpusiro + "pt";
				}
		} else {sel.paragraphs[0].ruleBelow = false;}
}

app.activeDocument.viewPreferences.textSizeMeasurementUnits = tsmu;
app.activeDocument.viewPreferences.strokeMeasurementUnits = lmu;